/*
 * gtkcooker: an abstraction layer on top of gtk
 * http://sed.free.fr/gtkcooker
 * Public domain.
 */

#ifndef _CODE_H_
#define _CODE_H_

/* this file is barbarian, but hey... */

/* properties */
#define CASE_PROPERTY_BORDER(x, l, i)						\
  case KEYWORD_BORDER: {						\
    if (type != PV_NUMBER) {						\
      fprintf(stderr, "widget %s: property \"border\" waits number\n",	\
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    WIDGET_BORDER_WIDTH(x) = list_get_float(l, (i)+2);			\
    break;								\
  }

#define CASE_PROPERTY_WIDTH(x)						\
  case KEYWORD_WIDTH: {							\
    if (type != PV_NUMBER) {						\
      fprintf(stderr, "widget %s: property \"width\" waits number\n",	\
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    WIDGET_WIDTH(x) = list_get_float(l, i+2);				\
    break;								\
  }

#define CASE_PROPERTY_HEIGHT(x)						\
  case KEYWORD_HEIGHT: {						\
    if (type != PV_NUMBER) {						\
      fprintf(stderr, "widget %s: property \"height\" waits number\n",	\
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    WIDGET_HEIGHT(x) = list_get_float(l, i+2);				\
    break;								\
  }

#define CASE_PROPERTY_BOX_SPACING(x, l, i)				\
  case KEYWORD_SPACING: {						\
    if (type != PV_NUMBER) {						\
      fprintf(stderr, "widget %s: property \"spacing\" waits number\n",	\
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    BOX_SPACING(x) = list_get_float(l, (i)+2);				\
    break;								\
  }

#define CASE_PROPERTY_HOMOGENEOUS(x, l, i)				\
  case KEYWORD_HOMOGENEOUS: {						\
    if (type != PV_KEYWORD) {						\
hom_err:								\
      fprintf(stderr,							\
          "widget %s: property \"homogeneous\" waits 'true' or 'false'\n", \
          get_identifier(widget_element_name(w, e)));			\
      return -1;							\
    }									\
    switch ((keyword)list_get_int(l, (i)+2)) {				\
      default:								\
        goto hom_err;							\
      case KEYWORD_TRUE:						\
        SET_HOMOGENEOUS(x, 1);						\
        break;								\
      case KEYWORD_FALSE:						\
        SET_HOMOGENEOUS(x, 0);						\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_BOX_DIRECTION(x)					\
  case KEYWORD_DIRECTION: {						\
    if (type != PV_KEYWORD) {						\
dir_err:								\
      fprintf(stderr,							\
     "widget %s: property \"direction\" waits 'horizontal' or 'vertical'\n", \
          get_identifier(widget_element_name(w, e)));			\
      return -1;							\
    }									\
    switch ((keyword)list_get_int(l, i+2)) {				\
      default:								\
        goto dir_err;							\
      case KEYWORD_HORIZONTAL:						\
        BOX_TYPE(x) = BOX_HORIZONTAL;					\
        break;								\
      case KEYWORD_VERTICAL:						\
        BOX_TYPE(x) = BOX_VERTICAL;					\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_GLOBAL(x)						\
  case KEYWORD_GLOBAL: {						\
    if (type != PV_KEYWORD) {						\
global_err:								\
      fprintf(stderr,							\
          "widget %s: property \"global\" waits 'true' or 'false'\n",	\
          get_identifier(widget_element_name(w, e)));			\
      return -1;							\
    }									\
    switch((keyword)list_get_int(l, i+2)) {				\
      default:								\
        goto global_err;						\
      case KEYWORD_TRUE:						\
        SET_GLOBAL(x, 1);						\
        break;								\
      case KEYWORD_FALSE:						\
        SET_GLOBAL(x, 0);						\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_FONT(x)						\
  case KEYWORD_FONT: {							\
    if (type != PV_STRING) {						\
      fprintf(stderr, "widget %s: property \"font\" waits a string\n",	\
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    WIDGET_FONT(x) = (string)list_get_int(l, i+2);			\
    break;								\
  }

#define CASE_PROPERTY_FOREGROUND(x)					\
  case KEYWORD_FOREGROUND: {						\
    if (type == PV_KEYWORD) {						\
      if ((keyword)list_get_int(l, i+2) != KEYWORD_DEFAULT)		\
        goto fg_err;							\
      WIDGET_FOREGROUND_NORMAL(x) = -2;					\
      WIDGET_FOREGROUND_ACTIVE(x) = -2;					\
      WIDGET_FOREGROUND_PRELIGHT(x) = -2;				\
      WIDGET_FOREGROUND_SELECTED(x) = -2;				\
      WIDGET_FOREGROUND_INSENSITIVE(x) = -2;				\
      break;								\
    }									\
    if (type != PV_STRING) {						\
fg_err:									\
      fprintf(stderr,							\
              "widget %s: property \"foreground\" waits a string\n",	\
              get_identifier(widget_element_name(w, e)));		\
      fprintf(stderr, "or 'default'\n");				\
      return -1;							\
    }									\
    WIDGET_FOREGROUND_NORMAL(x) = (string)list_get_int(l, i+2);		\
    WIDGET_FOREGROUND_ACTIVE(x) = (string)list_get_int(l, i+2);		\
    WIDGET_FOREGROUND_PRELIGHT(x) = (string)list_get_int(l, i+2);	\
    WIDGET_FOREGROUND_SELECTED(x) = (string)list_get_int(l, i+2);	\
    WIDGET_FOREGROUND_INSENSITIVE(x) = (string)list_get_int(l, i+2);	\
    break;								\
  }

#define CASE_PROPERTY_FOREGROUND_NORMAL(x)				\
  case KEYWORD_FOREGROUND_NORMAL: {					\
    if (type == PV_KEYWORD) {						\
      if ((keyword)list_get_int(l, i+2) != KEYWORD_DEFAULT)		\
        goto fg_no_err;							\
      WIDGET_FOREGROUND_NORMAL(x) = -2;					\
      break;								\
    }									\
    if (type != PV_STRING) {						\
fg_no_err:								\
      fprintf(stderr,							\
              "widget %s: property \"foreground_normal\" waits a string\n", \
              get_identifier(widget_element_name(w, e)));		\
      fprintf(stderr, "or 'default'\n");				\
      return -1;							\
    }									\
    WIDGET_FOREGROUND_NORMAL(x) = (string)list_get_int(l, i+2);		\
    break;								\
  }

#define CASE_PROPERTY_FOREGROUND_ACTIVE(x)				\
  case KEYWORD_FOREGROUND_ACTIVE: {					\
    if (type == PV_KEYWORD) {						\
      if ((keyword)list_get_int(l, i+2) != KEYWORD_DEFAULT)		\
        goto fg_ac_err;							\
      WIDGET_FOREGROUND_ACTIVE(x) = -2;					\
      break;								\
    }									\
    if (type != PV_STRING) {						\
fg_ac_err:								\
      fprintf(stderr,							\
              "widget %s: property \"foreground_active\" waits a string\n", \
              get_identifier(widget_element_name(w, e)));		\
      fprintf(stderr, "or 'default'\n");				\
      return -1;							\
    }									\
    WIDGET_FOREGROUND_ACTIVE(x) = (string)list_get_int(l, i+2);		\
    break;								\
  }

#define CASE_PROPERTY_FOREGROUND_PRELIGHT(x)				\
  case KEYWORD_FOREGROUND_PRELIGHT: {					\
    if (type == PV_KEYWORD) {						\
      if ((keyword)list_get_int(l, i+2) != KEYWORD_DEFAULT)		\
        goto fg_pr_err;							\
      WIDGET_FOREGROUND_PRELIGHT(x) = -2;				\
      break;								\
    }									\
    if (type != PV_STRING) {						\
fg_pr_err:								\
      fprintf(stderr,							\
              "widget %s: property \"foreground_prelight\" waits a string\n", \
              get_identifier(widget_element_name(w, e)));		\
      fprintf(stderr, "or 'default'\n");				\
      return -1;							\
    }									\
    WIDGET_FOREGROUND_PRELIGHT(x) = (string)list_get_int(l, i+2);	\
    break;								\
  }

#define CASE_PROPERTY_FOREGROUND_SELECTED(x)				\
  case KEYWORD_FOREGROUND_SELECTED: {					\
    if (type == PV_KEYWORD) {						\
      if ((keyword)list_get_int(l, i+2) != KEYWORD_DEFAULT)		\
        goto fg_se_err;							\
      WIDGET_FOREGROUND_SELECTED(x) = -2;				\
      break;								\
    }									\
    if (type != PV_STRING) {						\
fg_se_err:								\
      fprintf(stderr,							\
              "widget %s: property \"foreground_selected\" waits a string\n", \
              get_identifier(widget_element_name(w, e)));		\
      fprintf(stderr, "or 'default'\n");				\
      return -1;							\
    }									\
    WIDGET_FOREGROUND_SELECTED(x) = (string)list_get_int(l, i+2);	\
    break;								\
  }

#define CASE_PROPERTY_FOREGROUND_INSENSITIVE(x)				\
  case KEYWORD_FOREGROUND_INSENSITIVE: {				\
    if (type == PV_KEYWORD) {						\
      if ((keyword)list_get_int(l, i+2) != KEYWORD_DEFAULT)		\
        goto fg_in_err;							\
      WIDGET_FOREGROUND_INSENSITIVE(x) = -2;				\
      break;								\
    }									\
    if (type != PV_STRING) {						\
fg_in_err:								\
      fprintf(stderr,							\
          "widget %s: property \"foreground_insensitive\" waits a string\n", \
              get_identifier(widget_element_name(w, e)));		\
      fprintf(stderr, "or 'default'\n");				\
      return -1;							\
    }									\
    WIDGET_FOREGROUND_INSENSITIVE(x) = (string)list_get_int(l, i+2);	\
    break;								\
  }

#define CASE_PROPERTY_BACKGROUND(x)					\
  case KEYWORD_BACKGROUND: {						\
    if (type == PV_KEYWORD) {						\
      if ((keyword)list_get_int(l, i+2) != KEYWORD_DEFAULT)		\
        goto bg_err;							\
      WIDGET_BACKGROUND_NORMAL(x) = -2;					\
      WIDGET_BACKGROUND_ACTIVE(x) = -2;					\
      WIDGET_BACKGROUND_PRELIGHT(x) = -2;				\
      WIDGET_BACKGROUND_SELECTED(x) = -2;				\
      WIDGET_BACKGROUND_INSENSITIVE(x) = -2;				\
      break;								\
    }									\
    if (type != PV_STRING) {						\
bg_err:									\
      fprintf(stderr, "widget %s: property \"background\" waits a string ", \
              get_identifier(widget_element_name(w, e)));		\
      fprintf(stderr, "or 'default'\n");				\
      return -1;							\
    }									\
    WIDGET_BACKGROUND_NORMAL(x) = (string)list_get_int(l, i+2);		\
    WIDGET_BACKGROUND_ACTIVE(x) = (string)list_get_int(l, i+2);		\
    WIDGET_BACKGROUND_PRELIGHT(x) = (string)list_get_int(l, i+2);	\
    WIDGET_BACKGROUND_SELECTED(x) = (string)list_get_int(l, i+2);	\
    WIDGET_BACKGROUND_INSENSITIVE(x) = (string)list_get_int(l, i+2);	\
    break;								\
  }

#define CASE_PROPERTY_BACKGROUND_NORMAL(x)				\
  case KEYWORD_BACKGROUND_NORMAL: {					\
    if (type == PV_KEYWORD) {						\
      if ((keyword)list_get_int(l, i+2) != KEYWORD_DEFAULT)		\
        goto bg_nr_err;							\
      WIDGET_BACKGROUND_NORMAL(x) = -2;					\
      break;								\
    }									\
    if (type != PV_STRING) {						\
bg_nr_err:								\
      fprintf(stderr,							\
              "widget %s: property \"background_normal\" waits a string ", \
              get_identifier(widget_element_name(w, e)));		\
      fprintf(stderr, "or 'default'\n");				\
      return -1;							\
    }									\
    WIDGET_BACKGROUND_NORMAL(x) = (string)list_get_int(l, i+2);		\
    break;								\
  }

#define CASE_PROPERTY_BACKGROUND_ACTIVE(x)				\
  case KEYWORD_BACKGROUND_ACTIVE: {					\
    if (type == PV_KEYWORD) {						\
      if ((keyword)list_get_int(l, i+2) != KEYWORD_DEFAULT)		\
        goto bg_ac_err;							\
      WIDGET_BACKGROUND_ACTIVE(x) = -2;					\
      break;								\
    }									\
    if (type != PV_STRING) {						\
bg_ac_err:								\
      fprintf(stderr,							\
              "widget %s: property \"background_active\" waits a string ", \
              get_identifier(widget_element_name(w, e)));		\
      fprintf(stderr, "or 'default'\n");				\
      return -1;							\
    }									\
    WIDGET_BACKGROUND_ACTIVE(x) = (string)list_get_int(l, i+2);		\
    break;								\
  }

#define CASE_PROPERTY_BACKGROUND_PRELIGHT(x)				\
  case KEYWORD_BACKGROUND_PRELIGHT: {					\
    if (type == PV_KEYWORD) {						\
      if ((keyword)list_get_int(l, i+2) != KEYWORD_DEFAULT)		\
        goto bg_pr_err;							\
      WIDGET_BACKGROUND_PRELIGHT(x) = -2;				\
      break;								\
    }									\
    if (type != PV_STRING) {						\
bg_pr_err:								\
      fprintf(stderr,							\
              "widget %s: property \"background_prelight\" waits a string ", \
              get_identifier(widget_element_name(w, e)));		\
      fprintf(stderr, "or 'default'\n");				\
      return -1;							\
    }									\
    WIDGET_BACKGROUND_PRELIGHT(x) = (string)list_get_int(l, i+2);	\
    break;								\
  }

#define CASE_PROPERTY_BACKGROUND_SELECTED(x)				\
  case KEYWORD_BACKGROUND_SELECTED: {					\
    if (type == PV_KEYWORD) {						\
      if ((keyword)list_get_int(l, i+2) != KEYWORD_DEFAULT)		\
        goto bg_se_err;							\
      WIDGET_BACKGROUND_SELECTED(x) = -2;				\
      break;								\
    }									\
    if (type != PV_STRING) {						\
bg_se_err:								\
      fprintf(stderr,							\
              "widget %s: property \"background_selected\" waits a string ", \
              get_identifier(widget_element_name(w, e)));		\
      fprintf(stderr, "or 'default'\n");				\
      return -1;							\
    }									\
    WIDGET_BACKGROUND_SELECTED(x) = (string)list_get_int(l, i+2);	\
    break;								\
  }

#define CASE_PROPERTY_BACKGROUND_INSENSITIVE(x)				\
  case KEYWORD_BACKGROUND_INSENSITIVE: {				\
    if (type == PV_KEYWORD) {						\
      if ((keyword)list_get_int(l, i+2) != KEYWORD_DEFAULT)		\
        goto bg_in_err;							\
      WIDGET_BACKGROUND_INSENSITIVE(x) = -2;				\
      break;								\
    }									\
    if (type != PV_STRING) {						\
bg_in_err:								\
      fprintf(stderr,							\
          "widget %s: property \"background_insensitive\" waits a string ", \
              get_identifier(widget_element_name(w, e)));		\
      fprintf(stderr, "or 'default'\n");				\
      return -1;							\
    }									\
    WIDGET_BACKGROUND_INSENSITIVE(x) = (string)list_get_int(l, i+2);	\
    break;								\
  }

#define CASE_PROPERTY_FOREGROUND_AND_BACKGROUND(x)			\
  CASE_PROPERTY_FOREGROUND(x)						\
  CASE_PROPERTY_FOREGROUND_NORMAL(x)					\
  CASE_PROPERTY_FOREGROUND_ACTIVE(x)					\
  CASE_PROPERTY_FOREGROUND_PRELIGHT(x)					\
  CASE_PROPERTY_FOREGROUND_SELECTED(x)					\
  CASE_PROPERTY_FOREGROUND_INSENSITIVE(x)				\
  CASE_PROPERTY_BACKGROUND(x)						\
  CASE_PROPERTY_BACKGROUND_NORMAL(x)					\
  CASE_PROPERTY_BACKGROUND_ACTIVE(x)					\
  CASE_PROPERTY_BACKGROUND_PRELIGHT(x)					\
  CASE_PROPERTY_BACKGROUND_SELECTED(x)					\
  CASE_PROPERTY_BACKGROUND_INSENSITIVE(x)

#define CASE_PROPERTY_SCROLL(x)						\
  case KEYWORD_SCROLL: {						\
    if (type != PV_KEYWORD) {						\
scroll_err:								\
      fprintf(stderr,							\
          "widget %s: property \"scroll\" waits 'true' or 'false'\n",	\
          get_identifier(widget_element_name(w, e)));			\
      return -1;							\
    }									\
    switch ((keyword)list_get_int(l, i+2)) {				\
      default:								\
        goto scroll_err;						\
      case KEYWORD_TRUE:						\
        SET_SCROLL(x, 1);						\
        break;								\
      case KEYWORD_FALSE:						\
        SET_SCROLL(x, 0);						\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_HSCROLL(x)					\
  case KEYWORD_HSCROLL: {						\
    if (type != PV_KEYWORD) {						\
hscroll_err:								\
      fprintf(stderr,							\
   "widget %s: property \"hscroll\" waits 'always', 'automatic', 'never',\n", \
          get_identifier(widget_element_name(w, e)));			\
      fprintf(stderr, "    'top' or 'bottom'\n");			\
      return -1;							\
    }									\
    switch ((keyword)list_get_int(l, i+2)) {				\
      default:								\
        goto hscroll_err;						\
      case KEYWORD_ALWAYS:						\
        WIDGET_HSCROLL_TYPE(x) = SCROLL_ALWAYS;				\
        break;								\
      case KEYWORD_AUTOMATIC:						\
        WIDGET_HSCROLL_TYPE(x) = SCROLL_AUTOMATIC;			\
        break;								\
      case KEYWORD_NEVER:						\
        WIDGET_HSCROLL_TYPE(x) = SCROLL_NEVER;				\
        break;								\
      case KEYWORD_TOP:							\
        WIDGET_HSCROLL_POSITION(x) = SCROLL_TOP;			\
        break;								\
      case KEYWORD_BOTTOM:						\
        WIDGET_HSCROLL_POSITION(x) = SCROLL_BOTTOM;			\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_VSCROLL(x)					\
  case KEYWORD_VSCROLL: {						\
    if (type != PV_KEYWORD) {						\
vscroll_err:								\
      fprintf(stderr,							\
   "widget %s: property \"vscroll\" waits 'always', 'automatic', 'never',\n", \
          get_identifier(widget_element_name(w, e)));			\
      fprintf(stderr, "    'left' or 'right'\n");			\
      return -1;							\
    }									\
    switch ((keyword)list_get_int(l, i+2)) {				\
      default:								\
        goto vscroll_err;						\
      case KEYWORD_ALWAYS:						\
        WIDGET_VSCROLL_TYPE(x) = SCROLL_ALWAYS;				\
        break;								\
      case KEYWORD_AUTOMATIC:						\
        WIDGET_VSCROLL_TYPE(x) = SCROLL_AUTOMATIC;			\
        break;								\
      case KEYWORD_NEVER:						\
        WIDGET_VSCROLL_TYPE(x) = SCROLL_NEVER;				\
        break;								\
      case KEYWORD_LEFT:						\
        WIDGET_VSCROLL_POSITION(x) = SCROLL_LEFT;			\
        break;								\
      case KEYWORD_RIGHT:						\
        WIDGET_VSCROLL_POSITION(x) = SCROLL_RIGHT;			\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_GROW(x, l, i)					\
  case KEYWORD_GROW: {							\
    if (type != PV_KEYWORD) {						\
gro_err:								\
      fprintf(stderr,							\
        "widget %s: property \"grow\" waits 'none', 'expand' or 'fill'\n", \
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    switch ((keyword)list_get_int(l, (i)+2)) {				\
      default:								\
        goto gro_err;							\
      case KEYWORD_NONE:						\
        SET_EXPAND(x, 0);						\
        SET_FILL(x, 0);							\
        break;								\
      case KEYWORD_EXPAND:						\
        SET_EXPAND(x, 1);						\
        SET_FILL(x, 0);							\
        break;								\
      case KEYWORD_FILL:						\
        SET_EXPAND(x, 1);						\
        SET_FILL(x, 1);							\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_PADDING(x, l, i)					\
  case KEYWORD_PADDING: {						\
    if (type != PV_NUMBER) {						\
      fprintf(stderr, "widget %s: property \"padding\" waits number\n",	\
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    WIDGET_PADDING(x) = list_get_float(l, (i)+2);			\
    break;								\
  }

#define CASE_PROPERTY_SIGNAL(x, SIGNAME, signame)			\
  case KEYWORD_##SIGNAME: {						\
    identifier fname;							\
    if (type != PV_C_CODE) {						\
      fprintf(stderr, "widget %s: property \"%s\" waits C code\n",	\
              get_identifier(widget_element_name(w, e)), signame);	\
      return -1;							\
    }									\
    fname = new_name();							\
    if (fname == -1) return -1;						\
    if (list_add_int(WIDGET_SIGNALS(x), list_get_int(l, i)) == -1 ||	\
        list_add_int(WIDGET_SIGNALS(x), fname) == -1 ||			\
        list_add_int(WIDGET_SIGNALS(x), list_get_int(l, i+2)) == -1)	\
      return -1;							\
    break;								\
  }

#define CASE_PROPERTY_CLICKED(x) CASE_PROPERTY_SIGNAL(x, CLICKED, "clicked")

#define CASE_PROPERTY_EXPOSE(x) CASE_PROPERTY_SIGNAL(x, EXPOSE, "expose")

#define CASE_PROPERTY_POINTER(x) CASE_PROPERTY_SIGNAL(x, POINTER, "pointer")

#define CASE_PROPERTY_ENTER(x) CASE_PROPERTY_SIGNAL(x, ENTER, "enter")

#define CASE_PROPERTY_LEAVE(x) CASE_PROPERTY_SIGNAL(x, LEAVE, "leave")

#define CASE_PROPERTY_KEY(x) CASE_PROPERTY_SIGNAL(x, KEY, "key")

#define CASE_PROPERTY_FOCUS(x) CASE_PROPERTY_SIGNAL(x, FOCUS, "focus")

#define CASE_PROPERTY_OK(x) CASE_PROPERTY_SIGNAL(x, OK, "ok")

#define CASE_PROPERTY_CANCEL(x) CASE_PROPERTY_SIGNAL(x, CANCEL, "cancel")

#define CASE_PROPERTY_DELETE(x) CASE_PROPERTY_SIGNAL(x, DELETE, "delete")

#define CASE_PROPERTY_BUTTON_TYPE(x)					\
  case KEYWORD_TYPE: {							\
    if (type != PV_KEYWORD) {						\
typ_err:								\
      fprintf(stderr,							\
"widget %s: property \"type\" waits 'normal', 'toggle', 'check' or 'radio'\n",\
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    switch ((keyword)list_get_int(l, i+2)) {				\
      default:								\
        goto typ_err;							\
      case KEYWORD_NORMAL:						\
        BUTTON_TYPE(x) = BUTTON_NORMAL;					\
        break;								\
      case KEYWORD_TOGGLE:						\
        BUTTON_TYPE(x) = BUTTON_TOGGLE;					\
        break;								\
      case KEYWORD_CHECK:						\
        BUTTON_TYPE(x) = BUTTON_CHECK;					\
        break;								\
      case KEYWORD_RADIO:						\
        BUTTON_TYPE(x) = BUTTON_RADIO;					\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_BUTTON_GROUP(x)					\
  case KEYWORD_GROUP: {							\
    widget_element group;						\
    if (type != PV_IDENTIFIER) {					\
group_err:								\
      fprintf(stderr,							\
   "widget %s: property \"group\" waits identifier of a different button\n", \
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    group = widget_find_element(w, (identifier)list_get_int(l, i+2));	\
    if (group == -1) goto group_err;					\
    if (widget_element_type(w, group) != KEYWORD_BUTTON)		\
      goto group_err;							\
    {									\
      static int done=0;						\
      if (!done) {							\
        fprintf(stderr,							\
                "%s:%d:%s: rewrite, too slow\n",  __FILE__, __LINE__,	\
                __FUNCTION__);						\
        done = 1;							\
      }									\
    }									\
    if (!strcmp(get_identifier(widget_element_name(w, e)),		\
                get_identifier(widget_element_name(w, group))))		\
      goto group_err;							\
    /* we set the widget, not the gtk_widget because it might not exist yet \
     * gtk_widget will be set at second pass				\
     */									\
    BUTTON_GROUP(x) = group;						\
    break;								\
  }

#define CASE_PROPERTY_ACTIVE(x)						\
  case KEYWORD_ACTIVE: {						\
    if (type != PV_KEYWORD) {						\
active_err:								\
      fprintf(stderr,							\
          "widget %s: property \"active\" waits 'true' or 'false'\n",	\
          get_identifier(widget_element_name(w, e)));			\
      return -1;							\
    }									\
    switch ((keyword)list_get_int(l, i+2)) {				\
      default:								\
        goto active_err;						\
      case KEYWORD_TRUE:						\
        SET_ACTIVE(x, 1);						\
        break;								\
      case KEYWORD_FALSE:						\
        SET_ACTIVE(x, 0);						\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_MENU_ACTIVATE(x)					\
  case KEYWORD_ACTIVATE: {						\
    identifier fname;							\
    if (type != PV_C_CODE) {						\
      fprintf(stderr,							\
              "widget %s[%d]: property \"activate\" waits C code\n",	\
              get_identifier(widget_element_name(w, e)), son);		\
      return -1;							\
    }									\
    fname = new_name();							\
    if (fname == -1) return -1;						\
    if (list_add_int(WIDGET_SIGNALS(x), list_get_int(l, i)) == -1 ||	\
        list_add_int(WIDGET_SIGNALS(x), fname) == -1 ||			\
        list_add_int(WIDGET_SIGNALS(x), list_get_int(l, i+2)) == -1)	\
      return -1;							\
    break;								\
  }

#define CASE_PROPERTY_TEXT_ACTIVATE(x)					\
  case KEYWORD_ACTIVATE: {						\
    identifier fname;							\
    if (type != PV_C_CODE) {						\
      fprintf(stderr,							\
              "widget %s: property \"activate\" waits C code\n",	\
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    activate_property_set = 1;						\
    fname = new_name();							\
    if (fname == -1) return -1;						\
    if (list_add_int(WIDGET_SIGNALS(x), list_get_int(l, i)) == -1 ||	\
        list_add_int(WIDGET_SIGNALS(x), fname) == -1 ||			\
        list_add_int(WIDGET_SIGNALS(x), list_get_int(l, i+2)) == -1)	\
      return -1;							\
    break;								\
  }

#define CASE_PROPERTY_LIST_ACTIVATE(x)					\
  case KEYWORD_ACTIVATE: {						\
    identifier fname;							\
    if (type != PV_C_CODE) {						\
      fprintf(stderr,							\
              "widget %s: property \"activate\" waits C code\n",	\
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    fname = new_name();							\
    if (fname == -1) return -1;						\
    if (list_add_int(WIDGET_SIGNALS(x), list_get_int(l, i)) == -1 ||	\
        list_add_int(WIDGET_SIGNALS(x), fname) == -1 ||			\
        list_add_int(WIDGET_SIGNALS(x), list_get_int(l, i+2)) == -1)	\
      return -1;							\
    break;								\
  }

#define CASE_PROPERTY_IMAGE_SOURCE(x)					\
  case KEYWORD_SOURCE: {						\
    if (type != PV_KEYWORD) {						\
sou_err:								\
      fprintf(stderr,							\
              "widget %s: property \"source\" waits 'file' or 'memory'\n", \
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    switch ((keyword)list_get_int(l, i+2)) {				\
      default:								\
        goto sou_err;							\
      case KEYWORD_FILE:						\
        IMAGE_SOURCE_TYPE(x) = default_source;				\
        break;								\
      case KEYWORD_MEMORY:						\
        /* IMAGE_MEMORY is not allowed if the image was declared	\
         * with a string (something like image i("something"))		\
         */								\
        if (default_source == IMAGE_FILE_STRING) {			\
          fprintf(stderr,						\
        "widget %s: property \"source\" set as 'memory', but argument\n", \
                  get_identifier(widget_element_name(w, e)));		\
          fprintf(stderr,						\
                  "of image declaration is a string, not an identifer\n"); \
          return -1;							\
        }								\
        IMAGE_SOURCE_TYPE(x) = IMAGE_MEMORY;				\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_HALIGN(TYPE, x)					\
    case KEYWORD_HALIGN: {						\
      if (type == PV_NUMBER) {						\
        TYPE##_HALIGN(x) = list_get_float(l, i+2);			\
      } else if (type == PV_KEYWORD) {					\
        switch ((keyword)list_get_int(l, i+2)) {			\
          default:							\
            goto hal_err;						\
          case KEYWORD_LEFT:						\
            TYPE##_HALIGN(x) = 0.;					\
            break;							\
          case KEYWORD_RIGHT:						\
            TYPE##_HALIGN(x) = 1.;					\
            break;							\
          case KEYWORD_CENTER:						\
            TYPE##_HALIGN(x) = 0.5;					\
            break;							\
        }								\
      } else {								\
hal_err:								\
        fprintf(stderr,							\
"widget %s: property \"halign\" waits number or 'left', 'right', 'center'\n", \
                get_identifier(widget_element_name(w, e)));		\
        return -1;							\
      }									\
      break;								\
    }

#define CASE_PROPERTY_VALIGN(TYPE, x)					\
    case KEYWORD_VALIGN: {						\
      if (type == PV_NUMBER) {						\
        TYPE##_VALIGN(x) = list_get_float(l, i+2);			\
      } else if (type == PV_KEYWORD) {					\
        switch ((keyword)list_get_int(l, i+2)) {			\
          default:							\
            goto val_err;						\
          case KEYWORD_TOP:						\
            TYPE##_VALIGN(x) = 0.;					\
            break;							\
          case KEYWORD_BOTTOM:						\
            TYPE##_VALIGN(x) = 1.;					\
            break;							\
          case KEYWORD_CENTER:						\
            TYPE##_VALIGN(x) = 0.5;					\
            break;							\
        }								\
      } else {								\
val_err:								\
        fprintf(stderr,							\
"widget %s: property \"valign\" waits number or 'top', 'bottom', 'center'\n", \
                get_identifier(widget_element_name(w, e)));		\
        return -1;							\
      }									\
      break;								\
    }

#define CASE_PROPERTY_TEXT_TYPE(x)					\
  case KEYWORD_TYPE: {							\
    if (type != PV_KEYWORD) {						\
typ_err:								\
      fprintf(stderr,							\
        "widget %s: property \"type\" waits 'entry' or 'multilines'\n",	\
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    switch ((keyword)list_get_int(l, i+2)) {				\
      default:								\
        goto typ_err;							\
      case KEYWORD_ENTRY:						\
        TEXT_TYPE(x) = TEXT_ENTRY;					\
        break;								\
      case KEYWORD_MULTILINES:						\
        TEXT_TYPE(x) = TEXT_MULTILINES;					\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_WINDOW_DAD(x)					\
  case KEYWORD_DAD: {							\
    if (type != PV_IDENTIFIER) {					\
      fprintf(stderr,							\
   "widget %s: property \"dad\" waits identifier of another window\n",	\
              get_identifier(widget_element_name(w, e)));		\
      fprintf(stderr,							\
 "the other window can only be passed as a parameter of the widget\n");	\
      return -1;							\
    }									\
    WINDOW_DAD(x) = (identifier)list_get_int(l, i+2);			\
    break;								\
  }

#define CASE_PROPERTY_POSITION(TYPE, x)					\
  case KEYWORD_POSITION: {						\
    if (type != PV_KEYWORD) {						\
pos_err:								\
      fprintf(stderr,							\
  "widget %s: property \"position\" waits 'center', 'mouse' or 'dad'\n",\
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    switch ((keyword)list_get_int(l, i+2)) {				\
      default:								\
        goto pos_err;							\
      case KEYWORD_CENTER:						\
        TYPE##_POSITION(x) = POSITION_CENTER;				\
        break;								\
      case KEYWORD_MOUSE:						\
        TYPE##_POSITION(x) = POSITION_MOUSE;				\
        break;								\
      case KEYWORD_DAD:							\
        TYPE##_POSITION(x) = POSITION_DAD;				\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_WINDOW_POSITION(x)				\
  CASE_PROPERTY_POSITION(WINDOW, x)

#define CASE_PROPERTY_FILE_POSITION(x)					\
  CASE_PROPERTY_POSITION(FILE, x)

#define CASE_PROPERTY_WINDOW_MODAL(x)					\
  case KEYWORD_MODAL: {							\
    if (type != PV_KEYWORD) {						\
modal_err:								\
      fprintf(stderr,							\
        "widget %s: property \"modal\" waits 'true' or 'false'\n",	\
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    switch ((keyword)list_get_int(l, i+2)) {				\
      default:								\
        goto modal_err;							\
      case KEYWORD_TRUE:						\
        WINDOW_MODAL(x) = 1;						\
        break;								\
      case KEYWORD_FALSE:						\
        WINDOW_MODAL(x) = 0;						\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_MENU_ITEM_TYPE(x)					\
  case KEYWORD_TYPE: {							\
    if (type != PV_KEYWORD) {						\
typ_err:								\
      fprintf(stderr,							\
             "widget %s: property \"type\" waits 'normal' or 'check'\n",\
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    switch ((keyword)list_get_int(l, i+2)) {				\
      default:								\
        goto typ_err;							\
      case KEYWORD_NORMAL:						\
        MENU_ITEM_TYPE(x) = MENU_ITEM_NORMAL;				\
        break;								\
      case KEYWORD_CHECK:						\
        MENU_ITEM_TYPE(x) = MENU_ITEM_CHECK;				\
        break;								\
      case KEYWORD_RADIO:						\
        MENU_ITEM_TYPE(x) = MENU_ITEM_RADIO;				\
        break;								\
    }									\
    break;								\
  }

#define CASE_PROPERTY_MENU_ITEM_GROUP(x)				\
  case KEYWORD_GROUP: {							\
    widget_element group;						\
    if (type != PV_IDENTIFIER) {					\
group_err:								\
      fprintf(stderr,							\
   "widget %s: property \"group\" waits identifier of a different menu item and same dad menu\n", \
              get_identifier(widget_element_name(w, e)));		\
      return -1;							\
    }									\
    group = find_gtk_widget_by_name(					\
                get_identifier((identifier)list_get_int(l, i+2)));	\
    if (group == -1) goto group_err;					\
    if (GET_TYPE(WIDGET_TYPE(group)) != MENU_ITEM)			\
      goto group_err;							\
    {									\
      static int done=0;						\
      if (!done) {							\
        fprintf(stderr,							\
                "%s:%d:%s: rewrite, too slow\n",  __FILE__, __LINE__,	\
                __FUNCTION__);						\
        done = 1;							\
      }									\
    }									\
    if (!strcmp(get_identifier(WIDGET_NAME(x)),				\
                get_identifier(WIDGET_NAME(group))))			\
      goto group_err;							\
    MENU_ITEM_GROUP(x) = group;						\
    MENU_ITEM_TYPE(x) = MENU_ITEM_RADIO;				\
    MENU_ITEM_TYPE(group) = MENU_ITEM_RADIO;				\
    break;								\
  }

#define CASE_PROPERTY_DEFAULT						\
  default:								\
    /* unsupported property, print a warning */				\
    fprintf(stderr, "warning: unknown property \"%s\" for widget %s\n",	\
            get_keyword(id), get_identifier(widget_element_name(w, e))); \
    break;

#define CASE_PROPERTY_DEFAULT_ITEM					\
  default:								\
    /* unsupported property, print a warning */				\
    fprintf(stderr,							\
            "warning: unknown property \"%s\" for widget %s[%d]\n",	\
            get_keyword(id), get_identifier(widget_element_name(w, e)),	\
            son);							\
    break;

#define CASE_PROPERTY_DEFAULT_IN_PACKING				\
  default:								\
    /* unsupported property, print a warning */				\
    fprintf(stderr,							\
            "warning: unknown property \"%s\" in packing of widget %s\n", \
            get_keyword(id), get_identifier(widget_element_name(w, e))); \
    break;

/* populate properties */
#define POPULATE_PROPERTIES						\
  if (WIDGET_FONT(gw) != -1) {						\
    if (WIDGET_FONT(sw) == -1) {					\
      WIDGET_FONT(sw) = WIDGET_FONT(gw);				\
      has_to_populate = 1;						\
    }									\
  }									\
									\
  if (WIDGET_FOREGROUND_NORMAL(gw) != -1) {				\
    if (WIDGET_FOREGROUND_NORMAL(sw) == -1) {				\
      WIDGET_FOREGROUND_NORMAL(sw) = WIDGET_FOREGROUND_NORMAL(gw);	\
      has_to_populate = 1;						\
    }									\
  }									\
									\
  if (WIDGET_FOREGROUND_ACTIVE(gw) != -1) {				\
    if (WIDGET_FOREGROUND_ACTIVE(sw) == -1) {				\
      WIDGET_FOREGROUND_ACTIVE(sw) = WIDGET_FOREGROUND_ACTIVE(gw);	\
      has_to_populate = 1;						\
    }									\
  }									\
									\
  if (WIDGET_FOREGROUND_PRELIGHT(gw) != -1) {				\
    if (WIDGET_FOREGROUND_PRELIGHT(sw) == -1) {				\
      WIDGET_FOREGROUND_PRELIGHT(sw) = WIDGET_FOREGROUND_PRELIGHT(gw);	\
      has_to_populate = 1;						\
    }									\
  }									\
									\
  if (WIDGET_FOREGROUND_SELECTED(gw) != -1) {				\
    if (WIDGET_FOREGROUND_SELECTED(sw) == -1) {				\
      WIDGET_FOREGROUND_SELECTED(sw) = WIDGET_FOREGROUND_SELECTED(gw);	\
      has_to_populate = 1;						\
    }									\
  }									\
									\
  if (WIDGET_FOREGROUND_INSENSITIVE(gw) != -1) {			\
    if (WIDGET_FOREGROUND_INSENSITIVE(sw) == -1) {			\
      WIDGET_FOREGROUND_INSENSITIVE(sw) = WIDGET_FOREGROUND_INSENSITIVE(gw); \
      has_to_populate = 1;						\
    }									\
  }									\
									\
  if (WIDGET_BACKGROUND_NORMAL(gw) != -1) {				\
    if (WIDGET_BACKGROUND_NORMAL(sw) == -1) {				\
      WIDGET_BACKGROUND_NORMAL(sw) = WIDGET_BACKGROUND_NORMAL(gw);	\
      has_to_populate = 1;						\
    }									\
  }									\
									\
  if (WIDGET_BACKGROUND_ACTIVE(gw) != -1) {				\
    if (WIDGET_BACKGROUND_ACTIVE(sw) == -1) {				\
      WIDGET_BACKGROUND_ACTIVE(sw) = WIDGET_BACKGROUND_ACTIVE(gw);	\
      has_to_populate = 1;						\
    }									\
  }									\
									\
  if (WIDGET_BACKGROUND_PRELIGHT(gw) != -1) {				\
    if (WIDGET_BACKGROUND_PRELIGHT(sw) == -1) {				\
      WIDGET_BACKGROUND_PRELIGHT(sw) = WIDGET_BACKGROUND_PRELIGHT(gw);	\
      has_to_populate = 1;						\
    }									\
  }									\
									\
  if (WIDGET_BACKGROUND_SELECTED(gw) != -1) {				\
    if (WIDGET_BACKGROUND_SELECTED(sw) == -1) {				\
      WIDGET_BACKGROUND_SELECTED(sw) = WIDGET_BACKGROUND_SELECTED(gw);	\
      has_to_populate = 1;						\
    }									\
  }									\
									\
  if (WIDGET_BACKGROUND_INSENSITIVE(gw) != -1) {			\
    if (WIDGET_BACKGROUND_INSENSITIVE(sw) == -1) {			\
      WIDGET_BACKGROUND_INSENSITIVE(sw) = WIDGET_BACKGROUND_INSENSITIVE(gw); \
      has_to_populate = 1;						\
    }									\
  }

/* generate properties */
#define GENERATE_BORDER_WIDTH						\
  if (WIDGET_BORDER_WIDTH(gw) != -1) {					\
    char b[32];								\
    sprintf(b, "%d", WIDGET_BORDER_WIDTH(gw));				\
    PUT_C("  gtk_container_set_border_width(GTK_CONTAINER(");		\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C("), ");							\
    PUT_C(b);								\
    PUT_C(");\n");							\
  }

#define GENERATE_BORDER_WIDTH_TEXT					\
  if (WIDGET_BORDER_WIDTH(gw) != -1) {					\
    if (TEXT_TYPE(gw) == TEXT_ENTRY) {					\
      fprintf(stderr,							\
              "warning: setting border of text entry %s has no effect\n", \
              get_identifier(WIDGET_NAME(gw)));				\
    } else {								\
      char b[32];							\
      PUT_C("  gtk_container_set_border_width(GTK_CONTAINER(");		\
      if (IS_GLOBAL(gw)) PUT_C("this->");				\
      PUT_C(get_identifier(WIDGET_NAME(gw)));				\
      PUT_C("), ");							\
      sprintf(b, "%d", WIDGET_BORDER_WIDTH(gw));			\
      PUT_C(b);								\
      PUT_C(");\n");							\
    }									\
  }

#define GENERATE_BORDER_WIDTH_USING_PADDING				\
  if (WIDGET_BORDER_WIDTH(gw) != -1) {					\
    char b[32];								\
    PUT_C("  gtk_misc_set_padding(GTK_MISC(");				\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C("), ");							\
    sprintf(b, "%d", WIDGET_BORDER_WIDTH(gw));				\
    PUT_C(b);								\
    PUT_C(", ");							\
    PUT_C(b);								\
    PUT_C(");\n");							\
  }

#define GENERATE_WIDTH_AND_HEIGHT					\
  if (WIDGET_WIDTH(gw) != -1 || WIDGET_HEIGHT(gw) != -1) {		\
    char b[32];								\
    PUT_C("  gtk_widget_set_size_request(");				\
    if (hide_gtk)							\
      PUT_C("(GtkWidget *)");						\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", ");							\
    sprintf(b, "%d", WIDGET_WIDTH(gw));					\
    PUT_C(b);								\
    PUT_C(", ");							\
    sprintf(b, "%d", WIDGET_HEIGHT(gw));				\
    PUT_C(b);								\
    PUT_C(");\n");							\
  }

#define GENERATE_HALIGN_AND_VALIGN(TYPE)				\
  if (TYPE##_HALIGN(gw) != -1 || TYPE##_VALIGN(gw) != -1) {		\
    char b[128];							\
    float halign = TYPE##_HALIGN(gw);					\
    float valign = TYPE##_VALIGN(gw);					\
    if (halign == -1) halign = 0.5;					\
    if (valign == -1) valign = 0.5;					\
    PUT_C("  gtk_misc_set_alignment(GTK_MISC(");			\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C("), ");							\
    sprintf(b, "%f", halign);						\
    PUT_C(b);								\
    PUT_C(", ");							\
    sprintf(b, "%f", valign);						\
    PUT_C(b);								\
    PUT_C(");\n");							\
  }

#define GENERATE_FONT							\
  if (WIDGET_FONT(gw) != -1) {						\
    PUT_C("  {\n");							\
    PUT_C("    PangoFontDescription *_font_desc =\n");			\
    PUT_C("        pango_font_description_from_string(\"");		\
    PUT_C(get_string(WIDGET_FONT(gw)));					\
    PUT_C("\");\n");							\
    PUT_C("    gtk_widget_modify_font(");				\
    if (hide_gtk)							\
      PUT_C("(GtkWidget *)");						\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", _font_desc);\n");						\
    PUT_C("    pango_font_description_free(_font_desc);\n");		\
    PUT_C("  }\n");							\
  }

#define GENERATE_FOREGROUND_AND_BACKGROUND				\
  if (WIDGET_FOREGROUND_NORMAL(gw) != -1 &&				\
      WIDGET_FOREGROUND_NORMAL(gw) != -2) {				\
    PUT_C("  {\n");							\
    PUT_C("    PangoColor _pango_color;\n");				\
    PUT_C("    GdkColor _color;\n");					\
    PUT_C("    if (pango_color_parse(&_pango_color, \"");		\
    PUT_C(get_string(WIDGET_FOREGROUND_NORMAL(gw)));			\
    PUT_C("\")) {\n");							\
    PUT_C("      _color.red = _pango_color.red;\n");			\
    PUT_C("      _color.green = _pango_color.green;\n");		\
    PUT_C("     _color.blue = _pango_color.blue;\n");			\
    PUT_C("      gtk_widget_modify_fg(");				\
    if (hide_gtk)							\
      PUT_C("(GtkWidget *)");						\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", GTK_STATE_NORMAL, &_color);\n");				\
    PUT_C("    }\n");							\
    PUT_C("  }\n");							\
  }									\
									\
  if (WIDGET_FOREGROUND_ACTIVE(gw) != -1 &&				\
      WIDGET_FOREGROUND_ACTIVE(gw) != -2) {				\
    PUT_C("  {\n");							\
    PUT_C("    PangoColor _pango_color;\n");				\
    PUT_C("    GdkColor _color;\n");					\
    PUT_C("    if (pango_color_parse(&_pango_color, \"");		\
    PUT_C(get_string(WIDGET_FOREGROUND_ACTIVE(gw)));			\
    PUT_C("\")) {\n");							\
    PUT_C("      _color.red = _pango_color.red;\n");			\
    PUT_C("      _color.green = _pango_color.green;\n");		\
    PUT_C("     _color.blue = _pango_color.blue;\n");			\
    PUT_C("      gtk_widget_modify_fg(");				\
    if (hide_gtk)							\
      PUT_C("(GtkWidget *)");						\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", GTK_STATE_ACTIVE, &_color);\n");				\
    PUT_C("    }\n");							\
    PUT_C("  }\n");							\
  }									\
									\
  if (WIDGET_FOREGROUND_PRELIGHT(gw) != -1 &&				\
      WIDGET_FOREGROUND_PRELIGHT(gw) != -2) {				\
    PUT_C("  {\n");							\
    PUT_C("    PangoColor _pango_color;\n");				\
    PUT_C("    GdkColor _color;\n");					\
    PUT_C("    if (pango_color_parse(&_pango_color, \"");		\
    PUT_C(get_string(WIDGET_FOREGROUND_PRELIGHT(gw)));			\
    PUT_C("\")) {\n");							\
    PUT_C("      _color.red = _pango_color.red;\n");			\
    PUT_C("      _color.green = _pango_color.green;\n");		\
    PUT_C("     _color.blue = _pango_color.blue;\n");			\
    PUT_C("      gtk_widget_modify_fg(");				\
    if (hide_gtk)							\
      PUT_C("(GtkWidget *)");						\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", GTK_STATE_PRELIGHT, &_color);\n");				\
    PUT_C("    }\n");							\
    PUT_C("  }\n");							\
  }									\
									\
  if (WIDGET_FOREGROUND_SELECTED(gw) != -1 &&				\
      WIDGET_FOREGROUND_SELECTED(gw) != -2) {				\
    PUT_C("  {\n");							\
    PUT_C("    PangoColor _pango_color;\n");				\
    PUT_C("    GdkColor _color;\n");					\
    PUT_C("    if (pango_color_parse(&_pango_color, \"");		\
    PUT_C(get_string(WIDGET_FOREGROUND_SELECTED(gw)));			\
    PUT_C("\")) {\n");							\
    PUT_C("      _color.red = _pango_color.red;\n");			\
    PUT_C("      _color.green = _pango_color.green;\n");		\
    PUT_C("     _color.blue = _pango_color.blue;\n");			\
    PUT_C("      gtk_widget_modify_fg(");				\
    if (hide_gtk)							\
      PUT_C("(GtkWidget *)");						\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", GTK_STATE_SELECTED, &_color);\n");				\
    PUT_C("    }\n");							\
    PUT_C("  }\n");							\
  }									\
									\
  if (WIDGET_FOREGROUND_INSENSITIVE(gw) != -1 &&			\
      WIDGET_FOREGROUND_INSENSITIVE(gw) != -2) {			\
    PUT_C("  {\n");							\
    PUT_C("    PangoColor _pango_color;\n");				\
    PUT_C("    GdkColor _color;\n");					\
    PUT_C("    if (pango_color_parse(&_pango_color, \"");		\
    PUT_C(get_string(WIDGET_FOREGROUND_INSENSITIVE(gw)));		\
    PUT_C("\")) {\n");							\
    PUT_C("      _color.red = _pango_color.red;\n");			\
    PUT_C("      _color.green = _pango_color.green;\n");		\
    PUT_C("     _color.blue = _pango_color.blue;\n");			\
    PUT_C("      gtk_widget_modify_fg(");				\
    if (hide_gtk)							\
      PUT_C("(GtkWidget *)");						\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", GTK_STATE_INSENSITIVE, &_color);\n");			\
    PUT_C("    }\n");							\
    PUT_C("  }\n");							\
  }									\
									\
  if (WIDGET_BACKGROUND_NORMAL(gw) != -1 &&				\
      WIDGET_BACKGROUND_NORMAL(gw) != -2) {				\
    PUT_C("  {\n");							\
    PUT_C("    PangoColor _pango_color;\n");				\
    PUT_C("    GdkColor _color;\n");					\
    PUT_C("    if (pango_color_parse(&_pango_color, \"");		\
    PUT_C(get_string(WIDGET_BACKGROUND_NORMAL(gw)));			\
    PUT_C("\")) {\n");							\
    PUT_C("      _color.red = _pango_color.red;\n");			\
    PUT_C("      _color.green = _pango_color.green;\n");		\
    PUT_C("     _color.blue = _pango_color.blue;\n");			\
    PUT_C("      gtk_widget_modify_bg(");				\
    if (hide_gtk)							\
      PUT_C("(GtkWidget *)");						\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", GTK_STATE_NORMAL, &_color);\n");				\
    PUT_C("    }\n");							\
    PUT_C("  }\n");							\
  }									\
									\
  if (WIDGET_BACKGROUND_ACTIVE(gw) != -1 &&				\
      WIDGET_BACKGROUND_ACTIVE(gw) != -2) {				\
    PUT_C("  {\n");							\
    PUT_C("    PangoColor _pango_color;\n");				\
    PUT_C("    GdkColor _color;\n");					\
    PUT_C("    if (pango_color_parse(&_pango_color, \"");		\
    PUT_C(get_string(WIDGET_BACKGROUND_ACTIVE(gw)));			\
    PUT_C("\")) {\n");							\
    PUT_C("      _color.red = _pango_color.red;\n");			\
    PUT_C("      _color.green = _pango_color.green;\n");		\
    PUT_C("     _color.blue = _pango_color.blue;\n");			\
    PUT_C("      gtk_widget_modify_bg(");				\
    if (hide_gtk)							\
      PUT_C("(GtkWidget *)");						\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", GTK_STATE_ACTIVE, &_color);\n");				\
    PUT_C("    }\n");							\
    PUT_C("  }\n");							\
  }									\
									\
  if (WIDGET_BACKGROUND_PRELIGHT(gw) != -1 &&				\
      WIDGET_BACKGROUND_PRELIGHT(gw) != -2) {				\
    PUT_C("  {\n");							\
    PUT_C("    PangoColor _pango_color;\n");				\
    PUT_C("    GdkColor _color;\n");					\
    PUT_C("    if (pango_color_parse(&_pango_color, \"");		\
    PUT_C(get_string(WIDGET_BACKGROUND_PRELIGHT(gw)));			\
    PUT_C("\")) {\n");							\
    PUT_C("      _color.red = _pango_color.red;\n");			\
    PUT_C("      _color.green = _pango_color.green;\n");		\
    PUT_C("     _color.blue = _pango_color.blue;\n");			\
    PUT_C("      gtk_widget_modify_bg(");				\
    if (hide_gtk)							\
      PUT_C("(GtkWidget *)");						\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", GTK_STATE_PRELIGHT, &_color);\n");				\
    PUT_C("    }\n");							\
    PUT_C("  }\n");							\
  }									\
									\
  if (WIDGET_BACKGROUND_SELECTED(gw) != -1 &&				\
      WIDGET_BACKGROUND_SELECTED(gw) != -2) {				\
    PUT_C("  {\n");							\
    PUT_C("    PangoColor _pango_color;\n");				\
    PUT_C("    GdkColor _color;\n");					\
    PUT_C("    if (pango_color_parse(&_pango_color, \"");		\
    PUT_C(get_string(WIDGET_BACKGROUND_SELECTED(gw)));			\
    PUT_C("\")) {\n");							\
    PUT_C("      _color.red = _pango_color.red;\n");			\
    PUT_C("      _color.green = _pango_color.green;\n");		\
    PUT_C("     _color.blue = _pango_color.blue;\n");			\
    PUT_C("      gtk_widget_modify_bg(");				\
    if (hide_gtk)							\
      PUT_C("(GtkWidget *)");						\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", GTK_STATE_SELECTED, &_color);\n");				\
    PUT_C("    }\n");							\
    PUT_C("  }\n");							\
  }									\
									\
  if (WIDGET_BACKGROUND_INSENSITIVE(gw) != -1 &&			\
      WIDGET_BACKGROUND_INSENSITIVE(gw) != -2) {			\
    PUT_C("  {\n");							\
    PUT_C("    PangoColor _pango_color;\n");				\
    PUT_C("    GdkColor _color;\n");					\
    PUT_C("    if (pango_color_parse(&_pango_color, \"");		\
    PUT_C(get_string(WIDGET_BACKGROUND_INSENSITIVE(gw)));		\
    PUT_C("\")) {\n");							\
    PUT_C("      _color.red = _pango_color.red;\n");			\
    PUT_C("      _color.green = _pango_color.green;\n");		\
    PUT_C("     _color.blue = _pango_color.blue;\n");			\
    PUT_C("      gtk_widget_modify_bg(");				\
    if (hide_gtk)							\
      PUT_C("(GtkWidget *)");						\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", GTK_STATE_INSENSITIVE, &_color);\n");			\
    PUT_C("    }\n");							\
    PUT_C("  }\n");							\
  }

#define GENERATE_WINDOW_DAD						\
  if (WINDOW_DAD(gw) != -1) {						\
    PUT_C("  if (");							\
    PUT_C(get_identifier(WINDOW_DAD(gw)));				\
    PUT_C(")\n");							\
    PUT_C("    gtk_window_set_transient_for(GTK_WINDOW(");		\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C("), GTK_WINDOW(");						\
    PUT_C(get_identifier(WINDOW_DAD(gw)));				\
    PUT_C("));\n");							\
  }

#define GENERATE_POSITION(TYPE)						\
  if (TYPE##_POSITION(gw) != -1) {					\
    PUT_C("  gtk_window_set_position(GTK_WINDOW(");			\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C("), ");							\
    switch (TYPE##_POSITION(gw)) {					\
      case POSITION_CENTER:						\
        PUT_C("GTK_WIN_POS_CENTER");					\
        break;								\
      case POSITION_MOUSE:						\
        PUT_C("GTK_WIN_POS_MOUSE");					\
        break;								\
      case POSITION_DAD:						\
        PUT_C("GTK_WIN_POS_CENTER_ON_PARENT");				\
        break;								\
      default:								\
        /* do nothing */						\
        break;								\
    }									\
    PUT_C(");\n");							\
  }

#define GENERATE_WINDOW_POSITION					\
  GENERATE_POSITION(WINDOW)

#define GENERATE_FILE_POSITION						\
  GENERATE_POSITION(FILE)

#define GENERATE_WINDOW_MODAL						\
  if (WINDOW_MODAL(gw) != -1) {						\
    PUT_C("  gtk_window_set_modal(GTK_WINDOW(");			\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C("), ");							\
    if (WINDOW_MODAL(gw))						\
      PUT_C("TRUE");							\
    else								\
      PUT_C("FALSE");							\
    PUT_C(");\n");							\
  }

/* generate signal handlers */
#define CASE_GENERATE_SIGNAL_HANDLER_BUTTON_CLICKED			\
  case KEYWORD_CLICKED: {						\
    PUT_C("static void ");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("(GtkButton *_widget, ");					\
    PUT_C(widget_name(w));						\
    PUT_C(" *this)\n{\n  ");						\
    PUT_C(get_string((string)list_get_int(l, i+2)));			\
    PUT_C("\n}\n\n");							\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_HANDLER_FILE_OK				\
  case KEYWORD_OK: {							\
    PUT_C("static void ");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("(GtkButton *_widget, ");					\
    PUT_C(widget_name(w));						\
    PUT_C(" *this)\n{\n");						\
    PUT_C("  const char *filename;\n");					\
    PUT_C("  GtkWidget *_file = (GtkWidget*)_widget;\n");		\
    PUT_C("  while (GTK_WIDGET_TYPE(_file) !=");			\
    PUT_C(" GTK_TYPE_FILE_SELECTION)\n");				\
    PUT_C("    _file = gtk_widget_get_parent(_file);\n");		\
    PUT_C("  filename = gtk_file_selection_get_filename");		\
    PUT_C("(GTK_FILE_SELECTION(_file));\n  ");				\
    PUT_C(get_string((string)list_get_int(l, i+2)));			\
    PUT_C("\n}\n\n");							\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_HANDLER_FILE_CANCEL			\
  case KEYWORD_CANCEL: {						\
    PUT_C("static void ");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("(GtkButton *_widget, ");					\
    PUT_C(widget_name(w));						\
    PUT_C(" *this)\n{\n");						\
    PUT_C("  GtkWidget *_file = (GtkWidget*)_widget;\n");		\
    PUT_C("  while (GTK_WIDGET_TYPE(_file) !=");			\
    PUT_C(" GTK_TYPE_FILE_SELECTION)\n");				\
    PUT_C("    _file = gtk_widget_get_parent(_file);\n  ");		\
    PUT_C(get_string((string)list_get_int(l, i+2)));			\
    PUT_C("\n}\n\n");							\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_HANDLER_MENU_ITEM_ACTIVATE			\
  case KEYWORD_ACTIVATE: {						\
    PUT_C("static void ");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("(GtkMenuItem *_widget, ");					\
    PUT_C(widget_name(w));						\
    PUT_C(" *this)\n{\n  ");						\
    PUT_C(get_string((string)list_get_int(l, i+2)));			\
    PUT_C("\n}\n\n");							\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_HANDLER_TEXT_ACTIVATE			\
  case KEYWORD_ACTIVATE: {						\
    PUT_C("static void ");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("(GtkEntry *_widget, ");					\
    PUT_C(widget_name(w));						\
    PUT_C(" *this)\n{\n  ");						\
    PUT_C(get_string((string)list_get_int(l, i+2)));			\
    PUT_C("\n}\n\n");							\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_HANDLER_LIST_ACTIVATE			\
  case KEYWORD_ACTIVATE: {						\
    PUT_C("static void ");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("(GtkTreeView *_widget, ");					\
    PUT_C(widget_name(w));						\
    PUT_C(" *this)\n{\n");						\
    PUT_C("  GtkTreePath *_p;\n");					\
    PUT_C("  char *_t;\n");						\
    PUT_C("  int line;\n");						\
    PUT_C("  gtk_tree_view_get_cursor(_widget, &_p, NULL);\n");		\
    PUT_C("  if (!_p) return;\n");					\
    PUT_C("  _t = gtk_tree_path_to_string(_p);\n");			\
    PUT_C("  line = atoi(_t);\n");					\
    PUT_C("  g_free(_t);\n");						\
    PUT_C("  gtk_tree_path_free(_p);\n  ");				\
    PUT_C(get_string((string)list_get_int(l, i+2)));			\
    PUT_C("\n}\n\n");							\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_HANDLER_EXPOSE				\
  case KEYWORD_EXPOSE: {						\
    PUT_C("static gboolean ");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("(GtkWidget *_widget, GdkEventExpose *_event, ");		\
    PUT_C(widget_name(w));						\
    PUT_C(" *this)\n{\n");						\
    PUT_C("  int x = _event->area.x;\n");				\
    PUT_C("  int y = _event->area.y;\n");				\
    PUT_C("  int width = _event->area.width;\n");			\
    PUT_C("  int height = _event->area.height;\n");			\
    PUT_C("  \n  ");							\
    PUT_C(get_string((string)list_get_int(l, i+2)));			\
    PUT_C("\n  return TRUE;\n");					\
    PUT_C("}\n\n");							\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_HANDLER_POINTER				\
  case KEYWORD_POINTER: {						\
    PUT_C("static gboolean ");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("(GtkWidget *_widget, GdkEvent *_event, ");			\
    PUT_C(widget_name(w));						\
    PUT_C(" *this)\n{\n");						\
    PUT_C("  int x;\n");						\
    PUT_C("  int y;\n");						\
    PUT_C("  GdkEventType type = _event->type;\n");			\
    PUT_C("  int button = 0;\n");					\
    PUT_C("  switch (type) {\n");					\
    PUT_C("    default: return FALSE;\n");				\
    PUT_C("    case GDK_MOTION_NOTIFY:\n");				\
    PUT_C("      x = _event->motion.x;\n");				\
    PUT_C("      y = _event->motion.y;\n");				\
    PUT_C("      break;\n");						\
    PUT_C("    case GDK_BUTTON_PRESS:\n");				\
    PUT_C("    case GDK_2BUTTON_PRESS:\n");				\
    PUT_C("    case GDK_3BUTTON_PRESS:\n");				\
    PUT_C("    case GDK_BUTTON_RELEASE:\n");				\
    PUT_C("      x = _event->button.x;\n");				\
    PUT_C("      y = _event->button.y;\n");				\
    PUT_C("      button = _event->button.button;\n");			\
    PUT_C("      break;\n");						\
    PUT_C("  }\n");							\
    PUT_C("  \n  ");							\
    PUT_C(get_string((string)list_get_int(l, i+2)));			\
    PUT_C("\n  return TRUE;\n");					\
    PUT_C("}\n\n");							\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_HANDLER_ENTER_LEAVE(CASE)			\
  case KEYWORD_##CASE: {						\
    PUT_C("static gboolean ");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("(GtkWidget *_widget, GdkEventCrossing *_event, ");		\
    PUT_C(widget_name(w));						\
    PUT_C(" *this)\n{\n");						\
    PUT_C("  int x = _event->x;\n");					\
    PUT_C("  int y = _event->y;\n");					\
    PUT_C("  \n  ");							\
    PUT_C(get_string((string)list_get_int(l, i+2)));			\
    PUT_C("\n  return TRUE;\n");					\
    PUT_C("}\n\n");							\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_HANDLER_ENTER \
  CASE_GENERATE_SIGNAL_HANDLER_ENTER_LEAVE(ENTER)

#define CASE_GENERATE_SIGNAL_HANDLER_LEAVE \
  CASE_GENERATE_SIGNAL_HANDLER_ENTER_LEAVE(LEAVE)

#define CASE_GENERATE_SIGNAL_HANDLER_KEY				\
  case KEYWORD_KEY: {							\
    PUT_C("static gboolean ");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("(GtkWidget *_widget, GdkEventKey *_event, ");		\
    PUT_C(widget_name(w));						\
    PUT_C(" *this)\n{\n");						\
    PUT_C("  int key = _event->keyval;\n");				\
    PUT_C("  int modifier = _event->state;\n");				\
    PUT_C("  \n  ");							\
    PUT_C("  if (_event->type != GDK_KEY_PRESS) return TRUE;\n");	\
    PUT_C("#define HAS_CONTROL(x) ((x) & GDK_CONTROL_MASK)\n");		\
    PUT_C("#define HAS_SHIFT(x) ((x) & GDK_SHIFT_MASK)\n");		\
    PUT_C("  \n  ");							\
    PUT_C(get_string((string)list_get_int(l, i+2)));			\
    PUT_C("\n  return TRUE;\n");					\
    PUT_C("#undef HAS_CONTROL\n");					\
    PUT_C("#undef HAS_SHIFT\n");					\
    PUT_C("}\n\n");							\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_HANDLER_DELETE				\
  case KEYWORD_DELETE: {							\
    PUT_C("static gboolean ");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("(GtkWidget *_widget, GdkEvent *_event, ");			\
    PUT_C(widget_name(w));						\
    PUT_C(" *this)\n{\n");						\
    PUT_C(get_string((string)list_get_int(l, i+2)));			\
    PUT_C("\n  return TRUE;\n");					\
    PUT_C("}\n\n");							\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_HANDLER_FOCUS				\
  case KEYWORD_FOCUS: {							\
    PUT_C("static gboolean ");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("(GtkWidget *_widget, GdkEventFocus *_event, ");		\
    PUT_C(widget_name(w));						\
    PUT_C(" *this)\n{\n");						\
    PUT_C("  int in = _event->in;\n");					\
    PUT_C("  \n  ");							\
    PUT_C(get_string((string)list_get_int(l, i+2)));			\
    PUT_C("\n  return TRUE;\n");					\
    PUT_C("}\n\n");							\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_HANDLER_DEFAULT				\
  default:								\
    break; /* DO NOTHING */

/* generate signals */
#define CASE_GENERATE_SIGNAL(SIGNAME, signame)				\
  case KEYWORD_##SIGNAME: {						\
    PUT_C("  this->");							\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C("_");								\
    PUT_C(get_keyword(id));						\
    PUT_C(" = g_signal_connect(");					\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", \"");							\
    PUT_C(signame);							\
    PUT_C("\", G_CALLBACK(");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("), this);\n");						\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_BUTTON_CLICKED				\
  CASE_GENERATE_SIGNAL(CLICKED, "clicked")

#define CASE_GENERATE_SIGNAL_MENU_ITEM_ACTIVATE				\
  CASE_GENERATE_SIGNAL(ACTIVATE, "activate")

#define CASE_GENERATE_SIGNAL_TEXT_ACTIVATE				\
  CASE_GENERATE_SIGNAL(ACTIVATE, "activate")

#define CASE_GENERATE_SIGNAL_LIST_ACTIVATE				\
  CASE_GENERATE_SIGNAL(ACTIVATE, "cursor-changed")

#define CASE_GENERATE_SIGNAL_EXPOSE					\
  CASE_GENERATE_SIGNAL(EXPOSE, "expose-event")

#define CASE_GENERATE_SIGNAL_POINTER					\
  case KEYWORD_POINTER: {						\
    PUT_C("  this->");							\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C("_pointer_motion");						\
    PUT_C(" = g_signal_connect(");					\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", \"");							\
    PUT_C("motion-notify-event");					\
    PUT_C("\", G_CALLBACK(");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("), this);\n");						\
									\
    PUT_C("  this->");							\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C("_pointer_press");						\
    PUT_C(" = g_signal_connect(");					\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", \"");							\
    PUT_C("button-press-event");					\
    PUT_C("\", G_CALLBACK(");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("), this);\n");						\
									\
    PUT_C("  this->");							\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C("_pointer_release");						\
    PUT_C(" = g_signal_connect(");					\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", \"");							\
    PUT_C("button-release-event");					\
    PUT_C("\", G_CALLBACK(");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("), this);\n");						\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_ENTER					\
  CASE_GENERATE_SIGNAL(ENTER, "enter-notify-event")

#define CASE_GENERATE_SIGNAL_LEAVE					\
  CASE_GENERATE_SIGNAL(LEAVE, "leave-notify-event")

#define CASE_GENERATE_SIGNAL_KEY					\
  CASE_GENERATE_SIGNAL(KEY, "key-press-event")

#define CASE_GENERATE_SIGNAL_DELETE					\
  CASE_GENERATE_SIGNAL(DELETE, "delete-event")

#define CASE_GENERATE_SIGNAL_FOCUS					\
  case KEYWORD_FOCUS: {							\
    PUT_C("  this->");							\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C("_");								\
    PUT_C(get_keyword(id));						\
    PUT_C(" = g_signal_connect(");					\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", \"");							\
    PUT_C("focus-in-event");						\
    PUT_C("\", G_CALLBACK(");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("), this);\n");						\
    PUT_C("  this->");							\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C("_");								\
    PUT_C(get_keyword(id));						\
    PUT_C(" = g_signal_connect(");					\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(", \"");							\
    PUT_C("focus-out-event");						\
    PUT_C("\", G_CALLBACK(");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("), this);\n");						\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_FILE(SIGNAME, signame)			\
  case KEYWORD_##SIGNAME: {						\
    PUT_C("  this->");							\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C("_");								\
    PUT_C(get_keyword(id));						\
    PUT_C(" = g_signal_connect(GTK_FILE_SELECTION(");			\
    if (IS_GLOBAL(gw)) PUT_C("this->");					\
    PUT_C(get_identifier(WIDGET_NAME(gw)));				\
    PUT_C(")->");							\
    PUT_C(signame);							\
    PUT_C("_button, \"");						\
    PUT_C("clicked");							\
    PUT_C("\", G_CALLBACK(");						\
    PUT_C(get_identifier((identifier)list_get_int(l, i+1)));		\
    PUT_C("), this);\n");						\
    break;								\
  }

#define CASE_GENERATE_SIGNAL_OK						\
  CASE_GENERATE_SIGNAL_FILE(OK, "ok")

#define CASE_GENERATE_SIGNAL_CANCEL					\
  CASE_GENERATE_SIGNAL_FILE(CANCEL, "cancel")

#define CASE_GENERATE_SIGNAL_DEFAULT					\
  default:								\
    break; /* DO NOTHING */

/* event mask generation */
#define GENERATE_ADD_EVENT_POINTER					\
  PUT_C("  gtk_widget_add_events(");					\
  if (hide_gtk)								\
    PUT_C("(GtkWidget *)");						\
  if (IS_GLOBAL(gw)) PUT_C("this->");					\
  PUT_C(get_identifier(WIDGET_NAME(gw)));				\
  PUT_C(", \n");							\
  PUT_C("    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|\n");	\
  PUT_C("    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);\n");

#define GENERATE_ADD_EVENT_ENTER					\
  PUT_C("  gtk_widget_add_events(");					\
  if (hide_gtk)								\
    PUT_C("(GtkWidget *)");						\
  if (IS_GLOBAL(gw)) PUT_C("this->");					\
  PUT_C(get_identifier(WIDGET_NAME(gw)));				\
  PUT_C(", \n");							\
  PUT_C("    GDK_ENTER_NOTIFY_MASK);\n");

#define GENERATE_ADD_EVENT_LEAVE					\
  PUT_C("  gtk_widget_add_events(");					\
  if (hide_gtk)								\
    PUT_C("(GtkWidget *)");						\
  if (IS_GLOBAL(gw)) PUT_C("this->");					\
  PUT_C(get_identifier(WIDGET_NAME(gw)));				\
  PUT_C(", \n");							\
  PUT_C("    GDK_LEAVE_NOTIFY_MASK);\n");

#define GENERATE_ADD_EVENT_KEY						\
  PUT_C("  gtk_widget_add_events(");					\
  if (hide_gtk)								\
    PUT_C("(GtkWidget *)");						\
  if (IS_GLOBAL(gw)) PUT_C("this->");					\
  PUT_C(get_identifier(WIDGET_NAME(gw)));				\
  PUT_C(", \n");							\
  PUT_C("    GDK_KEY_PRESS_MASK);\n");

#endif /* _CODE_H_ */
