/*
 * gtkcooker: an abstraction layer on top of gtk
 * http://sed.free.fr/gtkcooker
 * Public domain.
 */

#include "identifier.h"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

static char *buffer;
static int size;
static int maxsize;

void close_identifier(void)
{
  if (!maxsize) return;

  free(buffer);

  buffer = 0;
  size = maxsize = 0;
}

/* return -1 if error, a new identifier if ok */
identifier new_identifier(char *s)
{
  int l = strlen(s)+1;

  if (size + l > maxsize) {
    int new_size = (size + l + 255) & ~255;
    char *new;
    if (!maxsize)
      new = malloc(new_size);
    else
      new = realloc(buffer, new_size);
    if (!new) {
      fprintf(stderr, "out of memory\n");
      return -1;
    }
    maxsize = new_size;
    buffer = new;
  }

  memcpy(buffer+size, s, l);
  size += l;

  return size-l;
}

char *get_identifier(identifier x)
{
  return buffer+x;
}
